/*
 *  Designed to run from Right Click of URL object
 *
 *  To install see "BMCOMENT.RIT"
 */

/*--- Get name of file make sure it exists ----------------------------------*/
trace off;
PgmVersion = '00.204';
UrlFile    = arg(1);
if stream(UrlFile, 'c', 'query exists') = '' then
   Die('The URL file "' || UrlFile || '" does not exist!');

/*--- Look through the file to see if there are any existing comments -------*/
FndCmt         = 'N';
CommentSection = "[BMCOMMENTS]";
CloseRc = stream(UrlFile, 'c', 'close');
do  while lines(UrlFile) <> 0
   /*--- Get next line ------------------------------------------------------*/
   if  translate(strip(linein(UrlFile))) = CommentSection then
   do
       FndCmt = 'Y';
       leave;
   end;
end;
CloseRc = stream(UrlFile, 'c', 'close');

/*--- Add Comment tags to end if they don't already exist -------------------*/
if FndCmt = 'N' then
do
   /*--- No existing comment ------------------------------------------------*/
   call lineout UrlFile, ''
   call lineout UrlFile, '[BmComments]'
   call lineout UrlFile, ''
   call lineout UrlFile, '[BmComments_]'
   CloseRc = stream(UrlFile, 'c', 'close');
end;

/*--- Edit the file ---------------------------------------------------------*/
address system 'start notepad.exe "' || UrlFile || '"';
exit(Rc);



/*===========================================================================*/
Die:
/*===========================================================================*/
   ExitCode = SIGL;
   say 'ERROR: ' || arg(1) || d2c(7);
   address system 'pause';
   exit(ExitCode);

