;----------------------------------------------------------------------------
;     MODULE NAME:   FAQ.H
;
;         $Author:   USER "Dennis"  $
;       $Revision:   1.0  $
;           $Date:   15 Feb 2001 15:11:00  $
;        $Logfile:   C:/DBAREIS/Projects.PVCS/PpwAddOn/FAQ/faq.h.pvcs  $
;
;     DESCRIPTION:   Generic FAQ support add-on to "OL_DOC.DH" or it can be
;                    used standalone.
;
;                    It allows you to define your FAQ questions and answers
;                    in a way which ignores presentation.
;
;                    The presentation can be tweeked via the large number
;                    of configuation parameters.
;----------------------------------------------------------------------------

;--- Define version number of header ----------------------------------------
#define+ VERSION_PPWFAQ_DH   01.045

;--- Validate user parameters -----------------------------------------------
#ifndef  FAQ_DATA_FILE
         #error ^You forgot to define "FAQ_DATA_FILE" (where your FAQ data is)^
#endif

;--- Is the user using my "OL_DOC" stuff?  If not set up a few macros -------
#ifndef  DocumentStart
   ;--- No so define some basic stuff that I need (at least by default) -----
   #define  DocType         HTML           ;;Only support HTML unless "OL_DOC.DH" being used
   #define? OrdListCompact  <ol>
   #define? eOrdListCompact </ol>
   #define? LI              <p><li>
   #define? P               <p>
   #define? P               <p>
   #define  OL_DOC_HTML_TOP
#endif

;--- Set up defaults for HTML pass 1 of the FAQ -----------------------------
#if    ['<$DocType>' = 'HTML']
   #define? FAQ1_HTML_Begin                <$OrdListCompact>
   #define? FAQ1_HTML_End                  <$eOrdListCompact>
   #define? FAQ1_HTML_QuestionLi           <$li>
   #define? FAQ1_HTML_QuestionMarkName     <A NAME="QUESTION_{$ID}">
   #define? FAQ1_HTML_QuestionLink2Answer  <A HREF="#ANSWER_{$ID}">
   #define? FAQ1_HTML_AnswerEndLink2Answer </A>
   #define? FAQ1_HTML_QuestionFormat
   #define? FAQ1_HTML_QuestionFormatEnd
#endif


;--- Initialization ---------------------------------------------------------
#AutoTagState + REMEMBER
#if    Symbol('FaqId') <> 'VAR'        ;;This variable unknown?
       #RexxVar  FaqId = 0             ;;First time this header included!
#endif
#RexxVar  FaqId + 1                    ;;Count times header used

;--- Set up macros for PASS 1 -----------------------------------------------
#RexxVar  FaqCount = 0
#if    ['<$DocType>' = 'HTML']
   ;--- HTML ----------------------------------------------------------------
   #define+ FaqBegin                                         \
            <A NAME="FAQ_BEGIN">                            %\
            <$FAQ1_HTML_Begin>
   #define+ FaqQuestion                                      \
            #RexxVar FaqCount + 1                           -\
            <?NewLine?>                                     -\
            <$FAQ1_HTML_QuestionMarkName ID=~{$ID=^<??FaqCount>^}~> -\
            <$FAQ1_HTML_QuestionLi>                         -\
            <$FAQ1_HTML_QuestionLink2Answer ID=~{$ID}~>     -\
            <$FAQ1_HTML_QuestionFormat>
   #define+ FaqAnswer                                        \
            <$FAQ1_HTML_QuestionFormatEnd>                  -\
            <$FAQ1_HTML_AnswerEndLink2Answer>               -\
            #output "NUL" ASIS APPEND ;;Drop output!
   #define  FaqAnswerEnd                                     \
            #output                   ;;Restore output
   #define+ FaqEnd                                           \
            <$FAQ1_HTML_End>
   #define+ FaqLinkQ                                         \
            <a href="#ANSWER_{$ID}">{$Text}</a>
#elseif
   ;--- IPF -----------------------------------------------------------------
   #define+ FaqBegin                                           \
            <$OrdListCompact>
   #define+ FaqQuestion                                        \
            #RexxVar FaqCount + 1                             -\
            <$li>                                             -\
            :link reftype=hd refid={$ID=^FAQ_<??FaqId>_ANSWER_<??FaqCount>^}.
   #define+ FaqAnswer                                          \
            :elink.                                           -\
            #output "NUL" ASIS APPEND ;;Drop output!
   #define  FaqAnswerEnd                                       \
            #output                   ;;Restore output
   #define+ FaqEnd                                             \
            <$eOrdListCompact>
#endif

;--- Include the FAQ data (for pass 1) --------------------------------------
#include "<$FAQ_DATA_FILE>"


;--- Generate any user defined code for between the passes ------------------
#ifdef FAQ_BETWEEN_PASSES
       <$FAQ_BETWEEN_PASSES>
#endif

;--- Set up defaults for HTML pass 2 of the FAQ -----------------------------
#if    ['<$DocType>' = 'HTML']
   #define? FAQ2_HTML_QuestionBefore   <HR size="1" color="red">
   #define? FAQ2_HTML_QuestionAfter
   #define? FAQ2_HTML_AnswerMarkName   <A NAME="ANSWER_{$ID}">
   #define? FAQ2_HTML_BeforeQuestion   <P><B><I>
   #define? FAQ2_HTML_AfterQuestion    </I></B></P>
   #define? FAQ2_HTML_BeforeAnswer     <P>
   #define? FAQ2_HTML_AfterAnswer      </P>
   #define? FAQ2_HTML_Back             <p><center><a href="#FAQ_BEGIN"><font size="-1">[top]</font></a></center>
#endif

;--- Set up macros for PASS 2 -----------------------------------------------
#RexxVar  FaqCount = 0
#if    ['<$DocType>' = 'HTML']
   ;--- HTML ----------------------------------------------------------------
   #define+ FaqBegin
   #define+ FaqQuestion                                    \
            #RexxVar FaqCount + 1                         -\
            <$FAQ2_HTML_QuestionBefore>                   -\
            <$FAQ2_HTML_AnswerMarkName ID=~{$ID=^<??FaqCount>^}~>  -\
            <$FAQ2_HTML_BeforeQuestion>
   #define+ FaqAnswer                                      \
            <$FAQ2_HTML_AfterQuestion>                    -\
            <$FAQ2_HTML_BeforeAnswer>
   #define+ FaqAnswerEnd                                   \
            <$FAQ2_HTML_AfterAnswer>                      -\
            <$FAQ2_HTML_Back>
   #define+ FaqEnd

   ;--- Set up some default handling ----------------------------------------
#elseif
   ;--- IPF -----------------------------------------------------------------
   #define+ FaqBegin       <$HeadingDown>
   #define+ FaqQuestion                                    \
            #RexxVar FaqCount + 1                         -\
            #if ['{$SHORT=''}' = '']                      -\
                <$Heading ID="{$ID=^FAQ_<??FaqId>_ANSWER_<??FaqCount>^}" TEXT="QUESTION #<??FaqCount>">            -\
            #elseif                                       -\
                <$Heading ID="{$ID=^FAQ_<??FaqId>_ANSWER_<??FaqCount>^}" TEXT="QUESTION #<??FaqCount> - {$Short}"> -\
            #endif                                        -\
            <$TITLE Text="QUESTION #<??FaqCount>">        %\
            <$BR>                                         %\
            <$BR>
   #define+ FaqAnswer                                      \
            <$TITLE Text="ANSWER">                        %\
            <$BR>                                         %\
            <$BR>
   #define+ FaqAnswerEnd
   #define+ FaqEnd         <$HeadingUp>
#endif

;--- Include the FAQ data (for pass 2) --------------------------------------
#include "<$FAQ_DATA_FILE>"

;--- termination ------------------------------------------------------------
#undef   FAQ_DATA_FILE             ;;User needs to define every time
#AutoTagState -



