;----------------------------------------------------------------------------
;     MODULE NAME:   SWF.H
;
;         $Author:   USER "Dennis"  $
;       $Revision:   1.1  $
;           $Date:   29 Jun 2001 19:41:06  $
;        $Logfile:   C:/DBAREIS/Projects.PVCS/PpwAddOn/swf/SWF.h.pvcs  $
;
;     DESCRIPTION:   This header allows you to easily obtain
;                    SWF (flash) information from files.
;
;                    The code was produced with help from
;                    Antonio Manara Rossini in Italy (thanks).
;
;----------------------------------------------------------------------------


;--- Only include once! -----------------------------------------------------
#ifdef VERSION_SWF_H
       #eof 1                      ;;No point reading rest of file!
#endif
#define VERSION_SWF_H    01.180
#require 01.018

;--- Set the default value for number of twips/pixel ------------------------
#define? SWF_TWIPS_PER_PIXEL 20

;--- By default die on error ------------------------------------------------
#define? SWF_DIE_ON_ERROR    Y     ;;Set to N for no if you want to check yourself!

;--- Some other values ------------------------------------------------------
#define?  SWF_OK   OK              ;;OK return code
#define   SWF_HEADER_SIZE    50    ;;Size can change (we expect it to be less than this)

;--- Start of our our own namespace -----------------------------------------
#NextId

;--- Create a macro containing code which can read SWF ----------------------
#DefineRexx 'SWF' NOPACK
   ;--- Get parameters ------------------------------------------------------
   @@FileUser = '{$File}';
   @@File     = @@FileUser;
   @@Stem     = '{$Stem=^SWF^}' || '.';    ;;User should not pass trailing '.'!

   ;--- Init values ---------------------------------------------------------
   @@Rc             = '<$SWF_OK>';
   @@ShortName      = '';
   @@ShortNameL     = '';
   @@ShortNameNE    = '';
   @@ShortNameLNE   = '';
   @@SignBytes      = '';
   @@Version        = 0;
   @@FileLength     = 0;
   @@FrameRate      = 0;
   @@FrameCount     = 0;
   @@XMinTwips      = 0;
   @@XMaxTwips      = 0;
   @@YMinTwips      = 0;
   @@YMaxTwips      = 0;
   @@HeightTwips    = 0;
   @@WidthTwips     = 0;

   ;--- Can the file be found as the user passed it? ------------------------
   @@File = QueryExists(@@FileUser);
   if  @@File = '' then
   do
       ;--- Look in user supplied seach paths -------------------------------
       #ifdef SWF_SEARCH_PATH
           ;--- User did not say where to look ------------------------------
           @@FullFile = FindFileInPath(@@FileUser, '<$SWF_SEARCH_PATH>')
       #elseif
           @@FullFile = '';
       #endif

       ;--- If still not found, look in "standard locations" ----------------
       if  @@FullFile = '' then
           @@FullFile = FindFile(@@FileUser)

       ;--- Update the user supplied name to a "fuller" one -----------------
       if  @@FullFile <> '' then
           @@File  = @@FullFile;           ;;We did find it
   end;

   ;--- Check file size (Lets pick figure on smallest file-------------------
   @@Lng = stream(@@File, 'c', 'query size');
   if  @@Lng <= <$SWF_HEADER_SIZE> then
   do
       if  @@Lng = '' then
           @@Rc = 'The flash file "' || @@FileUser || '" does not exist!';
       else
           @@Rc = 'The flash file "' || @@FileUser || '" is only ' || @@Lng || ' bytes long!';
   end;
   else
   do
       ;--- Read Header Bytes -----------------------------------------------
       @@Header = charin(@@File, 1, <$SWF_HEADER_SIZE>);
       CloseRc  = stream(@@File, 'c', 'close');
       if length(@@Header) <> <$SWF_HEADER_SIZE> then
          @@Rc = 'Could not read <$SWF_HEADER_SIZE> bytes SWF header from "' || @@FileUser || '"';
       else
       do
           ;--- Make sure it looks like an SWF header -----------------------
           @@SignBytes = substr(@@Header, 1, 3);
           if @@SignBytes <> 'FWS' then
              @@Rc = 'The flash file "' || @@FileUser || '" does not have valid SWF header';
           else
           do
               ;--- Get the filename in a number of handy formats -----------
               @@ShortName    = _filespec('name', @@File);
               @@ShortNameNE  = _filespec('withoutextn', @@ShortName);
               @@ShortNameL   = ToLowerCase(@@ShortName);
               @@ShortNameLNE = ToLowerCase(@@ShortNameNE);

               ;--- The version number is next ------------------------------
               @@StartByte  = 4
               @@Version = c2d(substr(@@Header, @@StartByte, 1));

               ;--- The size of the file ------------------------------------
               @@StartByte  = 5
               @@FileLength = c2d(reverse(substr(@@Header, @@StartByte, 4)));

               ;--- Get the size / coordinates ------------------------------
               @@StartByte  = 9
               @@HexStr = c2x(substr(@@Header, @@StartByte))  ;;Convert rest of header "1234"x ==> "1234"
               @@BinStr = x2b(@@HexStr);                      ;;Now has string of bits (0/1)
               @@Size   = x2d(b2x(left(@@BinStr,5)))          ;;Convert first 4 bits to decimal number (size of each following number in bits)
               @@XMinTwips = x2d(b2x(substr(@@BinStr,6,            @@Size)))
               @@XMaxTwips = x2d(b2x(substr(@@BinStr,6+@@Size,     @@Size)))
               @@YMinTwips = x2d(b2x(substr(@@BinStr,6+(@@Size*2), @@Size)))
               @@YMaxTwips = x2d(b2x(substr(@@BinStr,6+(@@Size*3), @@Size)))
               @@NumBits   = 5 + (4 * @@Size)
               @@NumBytes  = @@NumBits % 8     ;;Number of WHOLE bytes
               if  (@@NumBits // 8) <> 0 then
               do
                   ;--- We need to byte align -------------------------------
                   @@NumBytes = @@NumBytes + 1
               end
               @@StartByte = @@StartByte + @@NumBytes
               @@HeightTwips = @@YMaxTwips - @@YMinTwips;
               @@WidthTwips  = @@XMaxTwips - @@XMinTwips;

               ;--- Not sure how this field is handled (it is NOT a frame rate) ---
               @@FrameRate  = c2d(substr(@@Header, @@StartByte, 2));

               ;--- Get the number of frames --------------------------------
               @@StartByte  = @@StartByte + 2;
               @@FrameCount = c2d(reverse(substr(@@Header, @@StartByte, 2)));
           end;
       end;
   end;

   ;--- Set up the RC or die on error (if user allows) ----------------------
   if  @@Rc <> '<$SWF_OK>' & '<$SWF_DIE_ON_ERROR>' = 'Y' then
   do
       ;--- We had an error and user wants us to die ------------------------
       error(@@Rc);
   end;

   ;--- Update variable user indicated for results --------------------------
   call value @@Stem || 'ErrorText',           @@Rc;
   call value @@Stem || 'ShortName',           @@ShortName;
   call value @@Stem || 'ShortNameL',          @@ShortNameL;
   call value @@Stem || 'ShortNameNE',         @@ShortNameNE;
   call value @@Stem || 'ShortNameLNE',        @@ShortNameLNE;
   call value @@Stem || 'FileNameAsSupplied',  @@FileUser;
   call value @@Stem || 'FileName',            @@File;
   call value @@Stem || 'SWFSignature',        @@SignBytes;
   call value @@Stem || 'Version',             @@Version;
   call value @@Stem || 'FileLength',          @@FileLength;
   call value @@Stem || 'FrameRate',           @@FrameRate;
   call value @@Stem || 'FrameCount',          @@FrameCount;
   call value @@Stem || 'XMinTwips',           @@XMinTwips;
   call value @@Stem || 'XMaxTwips',           @@XMaxTwips;
   call value @@Stem || 'YMinTwips',           @@YMinTwips;
   call value @@Stem || 'YMaxTwips',           @@YMaxTwips;
   call value @@Stem || 'HeightTwips',         @@HeightTwips;
   call value @@Stem || 'WidthTwips',          @@WidthTwips;
   call value @@Stem || 'XMin',                @@XMinTwips   / <$SWF_TWIPS_PER_PIXEL>;
   call value @@Stem || 'XMax',                @@XMaxTwips   / <$SWF_TWIPS_PER_PIXEL>;
   call value @@Stem || 'YMin',                @@YMinTwips   / <$SWF_TWIPS_PER_PIXEL>;
   call value @@Stem || 'YMax',                @@YMaxTwips   / <$SWF_TWIPS_PER_PIXEL>;
   call value @@Stem || 'Height',              @@HeightTwips / <$SWF_TWIPS_PER_PIXEL>;
   call value @@Stem || 'Width',               @@WidthTwips  / <$SWF_TWIPS_PER_PIXEL>;
#DefineRexx

;--- End of our our own namespace -------------------------------------------
#NextId

